/**
 * BulkMutateJobServiceInterface.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.adwords.axis.v201109.cm;

public interface BulkMutateJobServiceInterface extends java.rmi.Remote {

    /**
     * Returns a list of bulk mutate jobs.
     *         
     *         
     * @param selector Specifies which jobs to return.
     *         If the selector is empty, all jobs are returned.
     *         
     * @return List of bulk mutate jobs meeting the {@code selector} criteria.
     * 
     * @throws ApiException if problems occurred while fetching the jobs
     */
    public com.google.api.ads.adwords.axis.v201109.cm.BulkMutateJob[] get(com.google.api.ads.adwords.axis.v201109.cm.BulkMutateJobSelector selector) throws java.rmi.RemoteException, com.google.api.ads.adwords.axis.v201109.cm.ApiException;

    /**
     * Adds or updates a bulk mutate job.
     *         
     *         <p>Use the &laquo;ADD&raquo; operator to submit a new job,
     * and the
     *         &laquo;SET&raquo; operator to add additional
     *         {@linkplain BulkMutateRequest request parts} to an existing
     * job.
     *         The &laquo;DELETE&raquo; operator is not supported.
     *         From v201008 and later, use the &laquo;REMOVE&raquo; operator
     * to
     *         cancel a job. Only jobs that still have pending additions
     * of request
     *         parts may be canceled.</p>
     *         
     *         <p class="note"><b>Note:</b> In the current implementation,
     * the check for
     *         duplicate job keys is only "best effort", and may not prevent
     * jobs with
     *         the same keys from being accepted if they are submitted around
     * the same
     *         instant.</p>
     *         
     *         
     * @param operation The operation to perform.
     *         
     * @throws ApiException if problems occurred while creating or updating
     * jobs
     *         
     * @return The added or updated bulk mutate job.
     */
    public com.google.api.ads.adwords.axis.v201109.cm.BulkMutateJob mutate(com.google.api.ads.adwords.axis.v201109.cm.JobOperation operation) throws java.rmi.RemoteException, com.google.api.ads.adwords.axis.v201109.cm.ApiException;
}
